const path = require('path')
const contentTmpl = './template/Content/index'

function pickerGenerator() {
  const tester = new RegExp(`^docs`)
  return markdownData => {
    const filename = markdownData.meta.filename
    if (tester.test(filename) && !/\/demo$/.test(path.dirname(filename))) {
      return {
        meta: markdownData.meta
      }
    }
  }
}

module.exports = {
  lazyLoad(nodePath, nodeValue) {
    if (typeof nodeValue === 'string') {
      return true
    }
    return nodePath.endsWith('/demo')
  },
  pick: {
    components(markdownData) {
      const filename = markdownData.meta.filename
      if (!/^components/.test(filename) || /[/\\]demo$/.test(path.dirname(filename))) return

      return {
        meta: markdownData.meta
      }
    },
    changelog(markdownData) {
      if (/CHANGELOG/.test(markdownData.meta.filename)) {
        return {
          meta: markdownData.meta
        }
      }
    },
    readme(markdownData) {
      if (/README/.test(markdownData.meta.filename)) {
        return {
          meta: markdownData.meta
        }
      }
    },
    'docs': pickerGenerator()
  },
  plugins: [
    'md-tools-plugin-highlight-react',
    'md-tools-plugin-description',
    'md-tools-plugin-toc',
    'md-tools-plugin-antd',
    'md-tools-plugin-image',
    'md-tools-plugin-react?lang=__react'
  ],
  routes: {
    path: '/',
    component: './template/Layout/index',
    redirectPath: '/readme/',
    indexRoute: { component: contentTmpl },
    childRoutes: [
      {
        path: 'docs/:children/',
        component: contentTmpl
      },
      {
        path: 'changelog/',
        component: contentTmpl
      },
      {
        path: 'readme/',
        component: contentTmpl
      },
      {
        path: 'components/:children/',
        component: contentTmpl
      }
    ]
  }
}
