import * as React from "react";
import { Icon, Badge, Clipboard } from "fish";

const CopyableIcon = ({ type, theme, isNew, justCopied, onCopied }) => {
  return (
    <Clipboard
      text={theme === "outlined" ? `<Icon type="${type}" />` : `<Icon type="${type}" theme="${theme}" />`}
      onCopy={() => onCopied(type)}
    >
      <li className={justCopied === type ? "copied" : ""}>
        <Icon type={type} theme={theme} />
        <span className="anticon-class">
          <Badge dot={isNew}>{type}</Badge>
        </span>
      </li>
    </Clipboard>
  );
};

export default CopyableIcon;
