import React, { cloneElement } from 'react'
import ReactDOM from 'react-dom'
import { addLocaleData, IntlProvider } from 'react-intl'
import Header from './Header'
import Footer from './Footer'
import cnLocale from '../../zh-CN'
import PropTypes from 'prop-types'
import createClass from 'create-react-class'
import 'moment/locale/zh-cn'
import moment from 'moment'
import { setHtmlDir } from '@sdp.nd/set-html-dir'

setHtmlDir()

if (!React.PropTypes) {
  React.PropTypes = PropTypes
}
if (!React.createClass) {
  React.createClass = createClass
}
if (typeof window !== 'undefined') {
  /* eslint-disable global-require */
  require('../../static/style')

  // Expose to iframe
  window.react = React
  window['react-dom'] = ReactDOM
  window.fish = require('fish')
  /* eslint-enable global-require */
}

export default class Layout extends React.Component {
  static contextTypes = {
    router: PropTypes.object.isRequired
  }

  constructor(props) {
    super(props)
    const appLocale = cnLocale
    addLocaleData(appLocale.data)
    moment.locale('zh-cn');
    this.state = {
      isFirstScreen: true,
      appLocale
    }
  }

  componentDidMount() {
    if (typeof window.ga !== 'undefined') {
      this.context.router.listen(loc => {
        window.ga('send', 'pageview', loc.pathname + loc.search)
      })
    }

    const nprogressHiddenStyle = document.getElementById('nprogress-style')
    if (nprogressHiddenStyle) {
      this.timer = setTimeout(() => {
        nprogressHiddenStyle.parentNode.removeChild(nprogressHiddenStyle)
      }, 0)
    }
  }

  componentWillUnmount() {
    clearTimeout(this.timer)
  }

  onEnterChange = mode => {
    this.setState({
      isFirstScreen: mode === 'enter'
    })
  }

  render() {
    const { children, ...restProps } = this.props
    const { appLocale, isFirstScreen } = this.state
    return (
      <IntlProvider locale={appLocale.locale} messages={appLocale.messages}>
        <div className="page-wrapper">
          <Header {...restProps} isFirstScreen={isFirstScreen} />
          {cloneElement(children, { onEnterChange: this.onEnterChange })}
          <Footer {...restProps} />
        </div>
      </IntlProvider>
    )
  }
}
